3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
12 git-clone [options] [--] <repo> [<dir>]
14 n,no-checkout don't create a checkout
15 bare create a bare repository
16 naked create a bare repository
17 l,local to clone from a local repository
18 no-hardlinks don't use local hardlinks, always copy
19 s,shared setup as a shared repository
20 template= path to the template directory
22 reference= reference repository
23 o,origin= use <name> instead of 'origin' to track upstream
24 u,upload-pack= path to git-upload-pack on the remote
25 depth= create a shallow clone of that depth
27 use-separate-remote compatibility, do not use
28 no-separate-remote compatibility, do not use"
39 eval "$(echo "$OPTIONS_SPEC" | git rev-parse --parseopt -- "$@" || echo exit $?)"
44 cd "$1" || cd "$1.git" &&
52 if [ -n "$GIT_SSL_NO_VERIFY" -o \
53 "`git config --bool http.sslVerify`" = false ]; then
58 # $1 = Remote, $2 = Local
59 curl -nsfL $curl_extra_args "$1" >"$2" ||
67 # $1 - remote, $2 - local
69 clone_tmp="$GIT_DIR/clone-tmp" &&
70 mkdir -p "$clone_tmp" || exit 1
71 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
72 "`git config --bool http.noEPSV`" = true ]; then
73 curl_extra_args="${curl_extra_args} --disable-epsv"
75 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
76 die "Cannot get remote repository information.
77 Perhaps git-update-server-info needs to be run there?"
78 test "z$quiet" = z && v=-v || v=
79 while read sha1 refname
81 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
86 yes,* | ,heads/* | ,tags/*) ;;
89 if test -n "$use_separate_remote" &&
90 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
92 tname="remotes/$origin/$branch_name"
96 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
97 done <"$clone_tmp/refs"
99 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
100 rm -f "$GIT_DIR/REMOTE_HEAD"
101 if test -f "$GIT_DIR/REMOTE_HEAD"; then
102 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
107 git-http-fetch $v -a "$head_sha1" "$1" ||
108 rm -f "$GIT_DIR/REMOTE_HEAD"
116 use_local_hardlink=yes
125 use_separate_remote=t
128 local_explicitly_asked_for=
129 test -t 1 || no_progress=--no-progress
139 local_explicitly_asked_for=yes
140 use_local_hardlink=yes
143 use_local_hardlink=no ;;
147 shift; template="--template=$1" ;;
150 --use-separate-remote|--no-separate-remote)
151 die "clones are always made with separate-remote layout" ;;
153 shift; reference="$1" ;;
160 die "'$1' is not suitable for an origin name"
162 git check-ref-format "heads/$1" ||
163 die "'$1' is not suitable for a branch name"
164 test -z "$origin_override" ||
165 die "Do not give more than one --origin options."
171 upload_pack="--upload-pack=$1" ;;
174 depth="--depth=$1" ;;
186 die 'you must specify a repository to clone.'
188 # --bare implies --no-checkout and --no-separate-remote
189 if test yes = "$bare"
191 if test yes = "$origin_override"
193 die '--bare and --origin $origin options are incompatible.'
204 # Turn the source into an absolute path if
206 if base=$(get_repo_base "$repo"); then
215 # Try using "humanish" part of source repo if user didn't specify one
216 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
217 [ -e "$dir" ] && die "destination directory '$dir' already exists."
218 [ yes = "$bare" ] && unset GIT_WORK_TREE
219 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
220 die "working tree '$GIT_WORK_TREE' already exists."
225 test -z "$D" && rm -rf "$dir"
226 test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
228 test -n "$D" && rm -rf "$D"
229 test -n "$W" && rm -rf "$W"
233 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
234 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
235 W=$(cd "$GIT_WORK_TREE" && pwd) && GIT_WORK_TREE="$W" && export GIT_WORK_TREE
236 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
242 GIT_CONFIG="$GIT_DIR/config" git-init $quiet ${template+"$template"} || usage
246 GIT_CONFIG="$GIT_DIR/config" git config core.bare true
249 if test -n "$reference"
252 if test -d "$reference"
254 if test -d "$reference/.git/objects"
256 ref_git="$reference/.git"
257 elif test -d "$reference/objects"
262 if test -n "$ref_git"
264 ref_git=$(cd "$ref_git" && pwd)
265 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
267 GIT_DIR="$ref_git" git for-each-ref \
268 --format='%(objectname) %(*objectname)'
273 git update-ref "refs/reference-tmp/$a" "$a"
275 git update-ref "refs/reference-tmp/$b" "$b"
278 die "reference repository '$reference' is not a local directory."
282 rm -f "$GIT_DIR/CLONE_HEAD"
284 # We do local magic only when the user tells us to.
287 ( cd "$repo/objects" ) ||
288 die "cannot chdir to local '$repo/objects'."
290 if test "$local_shared" = yes
292 mkdir -p "$GIT_DIR/objects/info"
293 echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
296 if test "$use_local_hardlink" = yes
298 # See if we can hardlink and drop "l" if not.
299 sample_file=$(cd "$repo" && \
300 find objects -type f -print | sed -e 1q)
301 # objects directory should not be empty because
303 test -f "$repo/$sample_file" ||
304 die "fatal: cannot clone empty repository"
305 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
307 rm -f "$GIT_DIR/objects/sample"
309 elif test -n "$local_explicitly_asked_for"
311 echo >&2 "Warning: -l asked but cannot hardlink to $repo"
315 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
317 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
324 *) die "shallow over rsync not supported" ;;
326 rsync $quiet -av --ignore-existing \
327 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
329 # Look at objects/info/alternates for rsync -- http will
330 # support it natively and git native ones will do it on the
331 # remote end. Not having that file is not a crime.
332 rsync -q "$repo/objects/info/alternates" \
333 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
334 rm -f "$GIT_DIR/TMP_ALT"
335 if test -f "$GIT_DIR/TMP_ALT"
338 . git-parse-remote &&
339 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
342 case "$alt" in 'bad alternate: '*) die "$alt";; esac
344 '') echo >&2 "Getting alternate: $alt" ;;
346 rsync $quiet -av --ignore-existing \
347 --exclude info "$alt" "$GIT_DIR/objects" || exit
349 rm -f "$GIT_DIR/TMP_ALT"
351 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
353 https://*|http://*|ftp://*)
356 *) die "shallow over http or ftp not supported" ;;
358 if test -z "@@NO_CURL@@"
360 clone_dumb_http "$repo" "$D"
362 die "http transport not supported, rebuild Git with curl support"
366 case "$upload_pack" in
367 '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
368 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
369 esac >"$GIT_DIR/CLONE_HEAD" ||
370 die "fetch-pack from '$repo' failed."
375 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
377 if test -f "$GIT_DIR/CLONE_HEAD"
379 # Read git-fetch-pack -k output and store the remote branches.
380 if [ -n "$use_separate_remote" ]
382 branch_top="remotes/$origin"
393 destname="REMOTE_HEAD" ;;
395 destname="refs/$branch_top/${name#refs/heads/}" ;;
397 destname="refs/$tag_top/${name#refs/tags/}" ;;
401 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
402 done < "$GIT_DIR/CLONE_HEAD"
405 if test -n "$W"; then
411 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
413 # a non-bare repository is always in separate-remote layout
414 remote_top="refs/remotes/$origin"
415 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
418 # Uh-oh, the remote told us (http transport done against
419 # new style repository with a symref HEAD).
420 # Ideally we should skip the guesswork but for now
421 # opt for minimum change.
422 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
423 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
427 # The name under $remote_top the remote HEAD seems to point at.
430 test -f "$GIT_DIR/$remote_top/master" && echo "master"
431 cd "$GIT_DIR/$remote_top" &&
432 find . -type f -print | sed -e 's/^\.\///'
437 test t = $done && continue
438 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
439 if test "$head_sha1" = "$branch_tip"
449 git config remote."$origin".url "$repo" &&
451 # Set up the mappings to track the remote branches.
452 git config remote."$origin".fetch \
453 "+refs/heads/*:$remote_top/*" '^$' &&
455 # Write out remote.$origin config, and update our "$head_points_at".
456 case "$head_points_at" in
458 # Local default branch
459 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
461 # Tracking branch for the primary branch at the remote.
462 git update-ref HEAD "$head_sha1" &&
464 rm -f "refs/remotes/$origin/HEAD"
465 git symbolic-ref "refs/remotes/$origin/HEAD" \
466 "refs/remotes/$origin/$head_points_at" &&
468 git config branch."$head_points_at".remote "$origin" &&
469 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
472 # Source had detached HEAD pointing nowhere
473 git update-ref --no-deref HEAD "$head_sha1" &&
474 rm -f "refs/remotes/$origin/HEAD"
478 case "$no_checkout" in
480 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
481 git read-tree -m -u $v HEAD HEAD
484 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"